// content/common/frame.mojom-test-utils.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CONTENT_COMMON_FRAME_MOJOM_TEST_UTILS_H_
#define CONTENT_COMMON_FRAME_MOJOM_TEST_UTILS_H_

#include "content/common/frame.mojom.h"
#include "content/common/content_export.h"


namespace content {
namespace mojom {


class CONTENT_EXPORT FrameHTMLSerializerHandlerInterceptorForTesting : public FrameHTMLSerializerHandler {
  virtual FrameHTMLSerializerHandler* GetForwardingInterface() = 0;
  void DidReceiveData(const std::string& data_buffer) override;
  void Done() override;
};
class CONTENT_EXPORT FrameHTMLSerializerHandlerAsyncWaiter {
 public:
  explicit FrameHTMLSerializerHandlerAsyncWaiter(FrameHTMLSerializerHandler* proxy);
  ~FrameHTMLSerializerHandlerAsyncWaiter();

 private:
  FrameHTMLSerializerHandler* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(FrameHTMLSerializerHandlerAsyncWaiter);
};


class CONTENT_EXPORT FrameInterceptorForTesting : public Frame {
  virtual Frame* GetForwardingInterface() = 0;
  void GetInterfaceProvider(::mojo::PendingReceiver<::service_manager::mojom::InterfaceProvider> interfaces) override;
  void GetCanonicalUrlForSharing(GetCanonicalUrlForSharingCallback callback) override;
  void BlockRequests() override;
  void ResumeBlockedRequests() override;
  void CancelBlockedRequests() override;
  void UpdateBrowserControlsState(::content::BrowserControlsState constraints, ::content::BrowserControlsState current, bool animate) override;
  void SnapshotAccessibilityTree(uint32_t ax_mode, SnapshotAccessibilityTreeCallback callback) override;
  void GetSerializedHtmlWithLocalLinks(const base::flat_map<::GURL, ::base::FilePath>& url_map, const base::flat_map<::base::UnguessableToken, ::base::FilePath>& frame_token_map, bool save_with_empty_url, ::mojo::PendingRemote<FrameHTMLSerializerHandler> handler_remote) override;
};
class CONTENT_EXPORT FrameAsyncWaiter {
 public:
  explicit FrameAsyncWaiter(Frame* proxy);
  ~FrameAsyncWaiter();
  void GetCanonicalUrlForSharing(
      base::Optional<::GURL>* out_canonical_url);
  void SnapshotAccessibilityTree(
      uint32_t ax_mode, ::ui::AXTreeUpdate* out_snapshot);

 private:
  Frame* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(FrameAsyncWaiter);
};


class CONTENT_EXPORT FrameNavigationControlInterceptorForTesting : public FrameNavigationControl {
  virtual FrameNavigationControl* GetForwardingInterface() = 0;
  void CommitSameDocumentNavigation(::content::mojom::CommonNavigationParamsPtr common_params, ::content::mojom::CommitNavigationParamsPtr request_params, CommitSameDocumentNavigationCallback callback) override;
  void HandleRendererDebugURL(const ::GURL& url) override;
  void UpdateSubresourceLoaderFactories(::std::unique_ptr<::blink::PendingURLLoaderFactoryBundle> subresource_loader_factories) override;
  void BindDevToolsAgent(::mojo::PendingAssociatedRemote<::blink::mojom::DevToolsAgentHost> agent_host, ::mojo::PendingAssociatedReceiver<::blink::mojom::DevToolsAgent> agent) override;
  void JavaScriptMethodExecuteRequest(const ::base::string16& object_name, const ::base::string16& method_name, ::base::Value arguments, bool wants_result, JavaScriptMethodExecuteRequestCallback callback) override;
  void JavaScriptExecuteRequest(const ::base::string16& javascript, bool wants_result, JavaScriptExecuteRequestCallback callback) override;
  void JavaScriptExecuteRequestForTests(const ::base::string16& javascript, bool wants_result, bool has_user_gesture, int32_t world_id, JavaScriptExecuteRequestForTestsCallback callback) override;
  void JavaScriptExecuteRequestInIsolatedWorld(const ::base::string16& javascript, bool wants_result, int32_t world_id, JavaScriptExecuteRequestInIsolatedWorldCallback callback) override;
  void SwapIn() override;
};
class CONTENT_EXPORT FrameNavigationControlAsyncWaiter {
 public:
  explicit FrameNavigationControlAsyncWaiter(FrameNavigationControl* proxy);
  ~FrameNavigationControlAsyncWaiter();
  void CommitSameDocumentNavigation(
      ::content::mojom::CommonNavigationParamsPtr common_params, ::content::mojom::CommitNavigationParamsPtr request_params, ::blink::mojom::CommitResult* out_commit_result);
  void JavaScriptMethodExecuteRequest(
      const ::base::string16& object_name, const ::base::string16& method_name, ::base::Value arguments, bool wants_result, ::base::Value* out_result);
  void JavaScriptExecuteRequest(
      const ::base::string16& javascript, bool wants_result, ::base::Value* out_result);
  void JavaScriptExecuteRequestForTests(
      const ::base::string16& javascript, bool wants_result, bool has_user_gesture, int32_t world_id, ::base::Value* out_result);
  void JavaScriptExecuteRequestInIsolatedWorld(
      const ::base::string16& javascript, bool wants_result, int32_t world_id, ::base::Value* out_result);

 private:
  FrameNavigationControl* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(FrameNavigationControlAsyncWaiter);
};


class CONTENT_EXPORT FrameBindingsControlInterceptorForTesting : public FrameBindingsControl {
  virtual FrameBindingsControl* GetForwardingInterface() = 0;
  void AllowBindings(int32_t enabled_bindings_flags) override;
  void EnableMojoJsBindings() override;
  void BindWebUI(::mojo::PendingReceiver<::content::mojom::WebUI> receiver, ::mojo::PendingRemote<::content::mojom::WebUIHost> remote) override;
};
class CONTENT_EXPORT FrameBindingsControlAsyncWaiter {
 public:
  explicit FrameBindingsControlAsyncWaiter(FrameBindingsControl* proxy);
  ~FrameBindingsControlAsyncWaiter();

 private:
  FrameBindingsControl* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(FrameBindingsControlAsyncWaiter);
};


class CONTENT_EXPORT FrameFactoryInterceptorForTesting : public FrameFactory {
  virtual FrameFactory* GetForwardingInterface() = 0;
  void CreateFrame(int32_t frame_routing_id, ::mojo::PendingReceiver<Frame> frame) override;
};
class CONTENT_EXPORT FrameFactoryAsyncWaiter {
 public:
  explicit FrameFactoryAsyncWaiter(FrameFactory* proxy);
  ~FrameFactoryAsyncWaiter();

 private:
  FrameFactory* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(FrameFactoryAsyncWaiter);
};


class CONTENT_EXPORT KeepAliveHandleInterceptorForTesting : public KeepAliveHandle {
  virtual KeepAliveHandle* GetForwardingInterface() = 0;
};
class CONTENT_EXPORT KeepAliveHandleAsyncWaiter {
 public:
  explicit KeepAliveHandleAsyncWaiter(KeepAliveHandle* proxy);
  ~KeepAliveHandleAsyncWaiter();

 private:
  KeepAliveHandle* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(KeepAliveHandleAsyncWaiter);
};


class CONTENT_EXPORT FrameHostInterceptorForTesting : public FrameHost {
  virtual FrameHost* GetForwardingInterface() = 0;
  void CreateNewWindow(CreateNewWindowParamsPtr params, CreateNewWindowCallback callback) override;
  void CreatePortal(::mojo::PendingAssociatedReceiver<::blink::mojom::Portal> portal, ::mojo::PendingAssociatedRemote<::blink::mojom::PortalClient> client, CreatePortalCallback callback) override;
  void AdoptPortal(const ::blink::PortalToken& portal_token, AdoptPortalCallback callback) override;
  void CreateNewWidget(::mojo::PendingAssociatedReceiver<::blink::mojom::WidgetHost> blink_widget_host, ::mojo::PendingAssociatedRemote<::blink::mojom::Widget> blink_widget, CreateNewWidgetCallback callback) override;
  void CreateNewFullscreenWidget(::mojo::PendingAssociatedReceiver<::blink::mojom::WidgetHost> blink_widget_host, ::mojo::PendingAssociatedRemote<::blink::mojom::Widget> blink_widget, CreateNewFullscreenWidgetCallback callback) override;
  void IssueKeepAliveHandle(::mojo::PendingReceiver<KeepAliveHandle> keep_alive_handle) override;
  void DidCommitProvisionalLoad(::std::unique_ptr<::FrameHostMsg_DidCommitProvisionalLoad_Params> params, ::content::mojom::DidCommitProvisionalLoadInterfaceParamsPtr interface_params) override;
  void DidCommitSameDocumentNavigation(::std::unique_ptr<::FrameHostMsg_DidCommitProvisionalLoad_Params> params) override;
  void BeginNavigation(::content::mojom::CommonNavigationParamsPtr common_params, ::content::mojom::BeginNavigationParamsPtr begin_params, ::mojo::PendingRemote<::blink::mojom::BlobURLToken> blob_url_token, ::mojo::PendingAssociatedRemote<::content::mojom::NavigationClient> navigation_client, ::mojo::PendingRemote<::blink::mojom::NavigationInitiator> navigation_initiator) override;
  void SubresourceResponseStarted(const ::GURL& url, uint32_t cert_status) override;
  void ResourceLoadComplete(::blink::mojom::ResourceLoadInfoPtr url_load_info) override;
  void DidChangeName(const std::string& name, const std::string& unique_name) override;
  void DidSetFramePolicyHeaders(::network::mojom::WebSandboxFlags sandbox_flags, const std::vector<::blink::ParsedFeaturePolicyDeclaration>& feature_policy_header, const base::flat_map<::blink::mojom::DocumentPolicyFeature, ::blink::PolicyValue>& document_policy_header) override;
  void CancelInitialHistoryLoad() override;
  void UpdateEncoding(const std::string& encoding_name) override;
  void FrameSizeChanged(const ::gfx::Size& size) override;
  void DidAddMessageToConsole(::blink::mojom::ConsoleMessageLevel log_level, const ::base::string16& msg, int32_t line_number, const ::base::string16& source_id) override;
  void ShowCreatedWindow(int32_t pending_widget_routing_id, ::WindowOpenDisposition disposition, const ::gfx::Rect& rect, bool opened_by_user_gesture) override;
  void UpdateState(const ::content::PageState& state) override;
  void OpenURL(OpenURLParamsPtr params) override;
  void DidStopLoading() override;
};
class CONTENT_EXPORT FrameHostAsyncWaiter {
 public:
  explicit FrameHostAsyncWaiter(FrameHost* proxy);
  ~FrameHostAsyncWaiter();
  void CreateNewWindow(
      CreateNewWindowParamsPtr params, CreateNewWindowStatus* out_status, CreateNewWindowReplyPtr* out_reply);
  void CreatePortal(
      ::mojo::PendingAssociatedReceiver<::blink::mojom::Portal> portal, ::mojo::PendingAssociatedRemote<::blink::mojom::PortalClient> client, int32_t* out_proxy_routing_id, ::content::FrameReplicationState* out_initial_replicated_state, ::blink::PortalToken* out_portal_token, ::base::UnguessableToken* out_frame_token, ::base::UnguessableToken* out_devtools_frame_token);
  void AdoptPortal(
      const ::blink::PortalToken& portal_token, int32_t* out_proxy_routing_id, ::viz::FrameSinkId* out_frame_sink_id, ::content::FrameReplicationState* out_replicated_state, ::base::UnguessableToken* out_frame_token, ::base::UnguessableToken* out_devtools_frame_token);
  void CreateNewWidget(
      ::mojo::PendingAssociatedReceiver<::blink::mojom::WidgetHost> blink_widget_host, ::mojo::PendingAssociatedRemote<::blink::mojom::Widget> blink_widget, int32_t* out_routing_id);
  void CreateNewFullscreenWidget(
      ::mojo::PendingAssociatedReceiver<::blink::mojom::WidgetHost> blink_widget_host, ::mojo::PendingAssociatedRemote<::blink::mojom::Widget> blink_widget, int32_t* out_routing_id);

 private:
  FrameHost* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(FrameHostAsyncWaiter);
};




}  // namespace mojom
}  // namespace content

#endif  // CONTENT_COMMON_FRAME_MOJOM_TEST_UTILS_H_