// services/network/public/mojom/cookie_manager.mojom-test-utils.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_NETWORK_PUBLIC_MOJOM_COOKIE_MANAGER_MOJOM_TEST_UTILS_H_
#define SERVICES_NETWORK_PUBLIC_MOJOM_COOKIE_MANAGER_MOJOM_TEST_UTILS_H_

#include "services/network/public/mojom/cookie_manager.mojom.h"


namespace network {
namespace mojom {


class  CookieChangeListenerInterceptorForTesting : public CookieChangeListener {
  virtual CookieChangeListener* GetForwardingInterface() = 0;
  void OnCookieChange(const ::net::CookieChangeInfo& change) override;
};
class  CookieChangeListenerAsyncWaiter {
 public:
  explicit CookieChangeListenerAsyncWaiter(CookieChangeListener* proxy);
  ~CookieChangeListenerAsyncWaiter();

 private:
  CookieChangeListener* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(CookieChangeListenerAsyncWaiter);
};


class  CookieRemoteAccessFilterInterceptorForTesting : public CookieRemoteAccessFilter {
  virtual CookieRemoteAccessFilter* GetForwardingInterface() = 0;
  void AllowedAccess(const ::GURL& url, const ::net::SiteForCookies& site_for_cookies, AllowedAccessCallback callback) override;
};
class  CookieRemoteAccessFilterAsyncWaiter {
 public:
  explicit CookieRemoteAccessFilterAsyncWaiter(CookieRemoteAccessFilter* proxy);
  ~CookieRemoteAccessFilterAsyncWaiter();
  void AllowedAccess(
      const ::GURL& url, const ::net::SiteForCookies& site_for_cookies, bool* out_allowed);

 private:
  CookieRemoteAccessFilter* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(CookieRemoteAccessFilterAsyncWaiter);
};


class  CookieManagerInterceptorForTesting : public CookieManager {
  virtual CookieManager* GetForwardingInterface() = 0;
  void GetAllCookies(GetAllCookiesCallback callback) override;
  void GetAllCookiesWithAccessSemantics(GetAllCookiesWithAccessSemanticsCallback callback) override;
  void GetCookieList(const ::GURL& url, const ::net::CookieOptions& cookie_options, GetCookieListCallback callback) override;
  void SetCanonicalCookie(const ::net::CanonicalCookie& cookie, const ::GURL& source_url, const ::net::CookieOptions& cookie_options, SetCanonicalCookieCallback callback) override;
  void DeleteCanonicalCookie(const ::net::CanonicalCookie& cookie, DeleteCanonicalCookieCallback callback) override;
  void DeleteCookies(CookieDeletionFilterPtr filter, DeleteCookiesCallback callback) override;
  void AddCookieChangeListener(const ::GURL& url, const base::Optional<std::string>& name, ::mojo::PendingRemote<CookieChangeListener> listener) override;
  void AddGlobalChangeListener(::mojo::PendingRemote<CookieChangeListener> notification_pointer) override;
  void CloneInterface(::mojo::PendingReceiver<CookieManager> new_interface) override;
  void FlushCookieStore(FlushCookieStoreCallback callback) override;
  void AllowFileSchemeCookies(bool allow, AllowFileSchemeCookiesCallback callback) override;
  void SetContentSettings(const std::vector<::ContentSettingPatternSource>& settings) override;
  void SetRemoteFilter(::mojo::PendingRemote<CookieRemoteAccessFilter> remote_access_filter) override;
  void SetForceKeepSessionState() override;
  void BlockThirdPartyCookies(bool block) override;
  void SetContentSettingsForLegacyCookieAccess(const std::vector<::ContentSettingPatternSource>& settings) override;
  void SetStorageAccessGrantSettings(const std::vector<::ContentSettingPatternSource>& settings, SetStorageAccessGrantSettingsCallback callback) override;
};
class  CookieManagerAsyncWaiter {
 public:
  explicit CookieManagerAsyncWaiter(CookieManager* proxy);
  ~CookieManagerAsyncWaiter();
  void GetAllCookies(
      std::vector<::net::CanonicalCookie>* out_cookies);
  void GetAllCookiesWithAccessSemantics(
      std::vector<::net::CanonicalCookie>* out_cookies, std::vector<::net::CookieAccessSemantics>* out_access_semantics_list);
  void GetCookieList(
      const ::GURL& url, const ::net::CookieOptions& cookie_options, std::vector<::net::CookieWithAccessResult>* out_cookies, std::vector<::net::CookieWithAccessResult>* out_excluded_cookies);
  void SetCanonicalCookie(
      const ::net::CanonicalCookie& cookie, const ::GURL& source_url, const ::net::CookieOptions& cookie_options, ::net::CookieAccessResult* out_access_result);
  void DeleteCanonicalCookie(
      const ::net::CanonicalCookie& cookie, bool* out_success);
  void DeleteCookies(
      CookieDeletionFilterPtr filter, uint32_t* out_num_deleted);
  void FlushCookieStore(
      );
  void AllowFileSchemeCookies(
      bool allow, bool* out_success);
  void SetStorageAccessGrantSettings(
      const std::vector<::ContentSettingPatternSource>& settings);

 private:
  CookieManager* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(CookieManagerAsyncWaiter);
};




}  // namespace mojom
}  // namespace network

#endif  // SERVICES_NETWORK_PUBLIC_MOJOM_COOKIE_MANAGER_MOJOM_TEST_UTILS_H_